package betterwithmods.module.hardcore.world;

import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMItems;
import betterwithmods.common.blocks.mechanical.BlockMechMachines;
import betterwithmods.common.entity.item.EntityItemBuoy;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.module.Feature;
import betterwithmods.util.item.StackMap;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.EnumDyeColor;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.Event;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.oredict.OreDictionary;

/**
 * @author Koward
 */
public class HCBuoy extends Feature {
    public static final StackMap<Float> buoyancy = new StackMap<>(-1.0F);

    public static float getBuoyancy(ItemStack stack) {
        return buoyancy.get(stack);
    }

    public static void initBuoyancy() {
        buoyancy.put("plankWood", 1.0F);
        buoyancy.put("treeSapling", 1.0F);
        buoyancy.put("treeLeaves", 1.0F);
        buoyancy.put(Blocks.field_150421_aI, 1.0F);
        buoyancy.put(Items.field_151104_aV, 1.0F);
        buoyancy.put(Blocks.field_150321_G, 1.0F);
        buoyancy.put(Blocks.field_150329_H, 1.0F);
        buoyancy.put(Blocks.field_150330_I, 1.0F);
        buoyancy.put(Blocks.field_150325_L, 1.0F);
        buoyancy.put(Blocks.field_150327_N, 1.0F);
        buoyancy.put(Blocks.field_150328_O, 1.0F);
        buoyancy.put(Blocks.field_150338_P, 1.0F);
        buoyancy.put(Blocks.field_150337_Q, 1.0F);
        buoyancy.put(Blocks.field_150335_W, 1.0F);
        buoyancy.put(Blocks.field_150342_X, 1.0F);
        buoyancy.put("torch", 1.0F);
        buoyancy.put("stairWood", 1.0F);
        buoyancy.put("chest", 1.0F);
        buoyancy.put("workbench", 1.0F);
        buoyancy.put("cropWheat", 1.0F);
        buoyancy.put("cropPotato", 1.0F);
        buoyancy.put("cropCarrot", 1.0F);
        buoyancy.put("cropNetherWart", 1.0F);
        buoyancy.put(Items.field_151155_ap, 1.0F);
        buoyancy.put(Items.field_179572_au, 1.0F);
        buoyancy.put(Items.field_179568_as, 1.0F);
        buoyancy.put(Items.field_179571_av, 1.0F);
        buoyancy.put(Items.field_179567_at, 1.0F);
        buoyancy.put(Items.field_179570_aq, 1.0F);
        buoyancy.put(Items.field_179569_ar, 1.0F);
        buoyancy.put(Blocks.field_150468_ap, 1.0F);
        buoyancy.put(Blocks.field_150452_aw, 1.0F);
        buoyancy.put(Blocks.field_150429_aA, 1.0F);
        buoyancy.put(Blocks.field_150431_aC, 1.0F);
        buoyancy.put(Blocks.field_150432_aD, 1.0F);
        buoyancy.put(Blocks.field_150433_aE, 1.0F);
        buoyancy.put("blockCactus", 1.0F);
        buoyancy.put("sugarcane", 1.0F);
        buoyancy.put(Blocks.field_180405_aT, 1.0F);
        buoyancy.put(Blocks.field_180404_aQ, 1.0F);
        buoyancy.put(Blocks.field_180406_aS, 1.0F);
        buoyancy.put(Blocks.field_180403_aR, 1.0F);
        buoyancy.put(Blocks.field_180407_aO, 1.0F);
        buoyancy.put(Blocks.field_180408_aP, 1.0F);
        buoyancy.put(Blocks.field_150423_aK, 1.0F);
        buoyancy.put(Blocks.field_150428_aP, 1.0F);
        buoyancy.put(Items.field_151105_aU, 1.0F);
        buoyancy.put(Blocks.field_150415_aT, 1.0F);
        buoyancy.put(Blocks.field_150420_aW, 1.0F);
        buoyancy.put(Blocks.field_150419_aX, 1.0F);
        buoyancy.put(Blocks.field_150440_ba, 1.0F);
        buoyancy.put("vine", 1.0F);
        buoyancy.put(Blocks.field_180387_bt, 1.0F);
        buoyancy.put(Blocks.field_180392_bq, 1.0F);
        buoyancy.put(Blocks.field_180385_bs, 1.0F);
        buoyancy.put(Blocks.field_180386_br, 1.0F);
        buoyancy.put(Blocks.field_180390_bo, 1.0F);
        buoyancy.put(Blocks.field_180391_bp, 1.0F);
        buoyancy.put(Blocks.field_150392_bi, 1.0F);
        buoyancy.put(Blocks.field_150376_bx, 1.0F);
        buoyancy.put(Items.field_151100_aR, 1.0F);
        buoyancy.put(Blocks.field_150471_bO, 1.0F);
        buoyancy.put(BWMBlocks.WOODEN_AXLE, 1.0F);
        buoyancy.put(BWMBlocks.PUMP, 0.0F);
        buoyancy.put(BWMBlocks.WOOD_SIDING, 1.0F);
        buoyancy.put(BWMBlocks.WOOD_MOULDING, 1.0F);
        buoyancy.put(BWMBlocks.WOOD_CORNER, 1.0F);
        buoyancy.put(BlockMechMachines.getStack(BlockMechMachines.EnumType.HOPPER), 1.0F);
        buoyancy.put(BWMBlocks.SAW, 1.0F);
        buoyancy.put(BWMBlocks.PLATFORM, 1.0F);
        buoyancy.put(BlockMechMachines.getStack(BlockMechMachines.EnumType.PULLEY), 1.0F);
        buoyancy.put(BWMBlocks.WOLF, 1.0F);
        buoyancy.put(BWMBlocks.HEMP, 1.0F);
        buoyancy.put(BWMBlocks.ROPE, 1.0F);
        buoyancy.put(BWMBlocks.WOODEN_GEARBOX, 1.0F);
        buoyancy.put(BWMBlocks.BELLOWS, 1.0F);
        buoyancy.put(BWMBlocks.VASE, 1.0F);
        buoyancy.put(Items.field_151034_e, 1.0F);
        buoyancy.put(Items.field_151031_f, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151032_g, 1.0F);
        buoyancy.put(Items.field_151041_m, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151038_n, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151039_o, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151053_p, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put("stick", 1.0F);
        buoyancy.put(Items.field_151054_z, 1.0F);
        buoyancy.put(Items.field_151009_A, 1.0F);
        buoyancy.put(Items.field_185165_cW, 1.0F);
        buoyancy.put("feather", 1.0F);
        buoyancy.put(Items.field_151017_I, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_185163_cU, 1.0F);
        buoyancy.put(Items.field_151081_bc, 1.0F);
        buoyancy.put(Items.field_151080_bb, 1.0F);
        buoyancy.put(Items.field_151014_N, 1.0F);
        buoyancy.put(Items.field_151025_P, 1.0F);
        buoyancy.put(Items.field_151024_Q, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151027_R, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151026_S, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151021_T, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151147_al, 1.0F);
        buoyancy.put(Items.field_151157_am, 1.0F);
        buoyancy.put(Items.field_151159_an, 1.0F);
        buoyancy.put(Items.field_151155_ap, 1.0F);
        buoyancy.put(Items.field_151141_av, 1.0F);
        buoyancy.put(Items.field_151126_ay, 1.0F);
        buoyancy.put(Items.field_151124_az, 1.0F);
        buoyancy.put(Items.field_185153_aK, 1.0F);
        buoyancy.put(Items.field_185151_aI, 1.0F);
        buoyancy.put(Items.field_185154_aL, 1.0F);
        buoyancy.put(Items.field_185152_aJ, 1.0F);
        buoyancy.put(Items.field_185150_aH, 1.0F);
        buoyancy.put("leather", 1.0F);
        buoyancy.put(Items.field_151121_aF, 1.0F);
        buoyancy.put(Items.field_151122_aG, 1.0F);
        buoyancy.put("slimeball", 1.0F);
        buoyancy.put(Items.field_151112_aM, OreDictionary.WILDCARD_VALUE, 1.0F);
        buoyancy.put(Items.field_151115_aP, 1.0F);
        buoyancy.put(Items.field_179566_aV, 1.0F);
        buoyancy.put("bone", 1.0F);
        buoyancy.put(Items.field_151102_aT, 1.0F);
        buoyancy.put(Items.field_151106_aX, 1.0F);
        buoyancy.put(Items.field_151148_bJ, 1.0F);
        buoyancy.put(Items.field_151127_ba, 1.0F);
        buoyancy.put(Items.field_151082_bd, 1.0F);
        buoyancy.put(Items.field_151083_be, 1.0F);
        buoyancy.put(Items.field_151076_bf, 1.0F);
        buoyancy.put(Items.field_151077_bg, 1.0F);
        buoyancy.put(Items.field_179561_bm, 1.0F);
        buoyancy.put(Items.field_179557_bn, 1.0F);
        buoyancy.put(Items.field_151078_bh, 1.0F);
        buoyancy.put(Items.field_151068_bn, 1.0F);
        buoyancy.put(Items.field_151069_bo, 1.0F);
        buoyancy.put(Items.field_151070_bp, 1.0F);
        buoyancy.put(Items.field_151071_bq, 1.0F);
        buoyancy.put(Items.field_151064_bs, 1.0F);
        buoyancy.put(Items.field_151099_bA, 1.0F);
        buoyancy.put(Items.field_151164_bB, 1.0F);
        buoyancy.put(Items.field_151160_bD, 1.0F);
        buoyancy.put(Items.field_151162_bE, 1.0F);
        buoyancy.put(Items.field_151168_bH, 1.0F);
        buoyancy.put(Items.field_151170_bI, 1.0F);
        buoyancy.put(Items.field_151098_aY, 1.0F);
        buoyancy.put(Items.field_151144_bL, 1.0F);
        buoyancy.put(Items.field_151146_bM, 1.0F);
        buoyancy.put(Items.field_151158_bO, 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.HEMP).func_77960_j(), 1.0F);
        buoyancy.put("gearWood", 1.0F);
        buoyancy.put("foodFlour", 1.0F);
        buoyancy.put("string", 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.HEMP_FIBERS).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.SCOURED_LEATHER).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.DONUT, 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.DUNG).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.AXLE_GENERATOR, 1.0F);
        buoyancy.put("fabricHemp", 1.0F);
        buoyancy.put(BWMItems.DONUT, 1.0F);
        buoyancy.put(BWMItems.DONUT, 1.0F);
        buoyancy.put(BWMBlocks.GRATE, 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.TANNED_LEATHER).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.LEATHER_STRAP).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.LEATHER_BELT).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.WOOD_BLADE).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.GLUE).func_77960_j(), 0.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.TALLOW).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.HAFT).func_77960_j(), 1.0F);
        buoyancy.put(BWMBlocks.URN, 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.SAWDUST).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.DYNAMITE, 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.SOUL_DUST).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.NETHER_SLUDGE).func_77960_j(), 1.0F);
        buoyancy.put(Items.field_151172_bF, 1.0F);
        buoyancy.put(BWMItems.CREEPER_OYSTER, 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.LEATHER_CUT).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.TANNED_LEATHER_CUT).func_77960_j(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.SCOURED_LEATHER_CUT).func_77960_j(), 1.0F);
        buoyancy.put("barkWood", 1.0F);
        buoyancy.put(Items.field_151100_aR, EnumDyeColor.BROWN.func_176767_b(), 1.0F);
        buoyancy.put(BWMItems.MATERIAL, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.SOUL_FLUX).func_77960_j(), 1.0F);
        buoyancy.put(BWMBlocks.STUMP, 1.0F);
        buoyancy.put(BWMItems.STUMP_REMOVER, 1.0F);
    }

    @Override
    public String getFeatureDescription() {
        return "Makes it so items float or not depending on their material properties";
    }

    @Override
    public void init(FMLInitializationEvent event) {
        initBuoyancy();
    }

    @Override
    public boolean requiresMinecraftRestartToEnable() {
        return true;
    }
    /**
     * Substitute the original {@link EntityItem} by our new {@link EntityItemBuoy}.
     */
    @SubscribeEvent
    public void replaceServerEntityItem(EntityJoinWorldEvent event) {
        World world = event.getWorld();
        if (world.field_72995_K) return;

        if (!(event.getEntity().getClass() == EntityItem.class)) return;
        EntityItem entityItem = (EntityItem) event.getEntity();

        if (entityItem.func_92059_d().func_190916_E() > 0) {
            event.setResult(Event.Result.DENY);
            EntityItemBuoy newEntity = new EntityItemBuoy(entityItem);
            newEntity.setWatchItem(entityItem);

            world.func_72838_d(newEntity);
        }
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }
}
